package com.gxzc.zen.api.sys.service.impl

import com.baomidou.mybatisplus.service.impl.ServiceImpl
import com.gxzc.zen.api.sys.mapper.SysPermissionMapper
import com.gxzc.zen.api.sys.model.SysPermission
import com.gxzc.zen.api.sys.service.ISysPermissionService
import com.gxzc.zen.api.sys.service.ISysUserRoleService
import com.gxzc.zen.common.contants.CACHEKEYS
import org.springframework.beans.factory.annotation.Autowired
import org.springframework.cache.annotation.Cacheable
import org.springframework.stereotype.Service

/**
 * <p>
 * 权限表 服务实现类
 * </p>
 *
 * @author NorthLan123
 * @since 2018-02-06
 */
@Service
class SysPermissionServiceImpl : ServiceImpl<SysPermissionMapper, SysPermission>(), ISysPermissionService {

    @Autowired
    private lateinit var sysUserRoleService: ISysUserRoleService

    /**
     * 获取指定用户的所有权限并缓存
     * 任何对 用户id
     */
    @Cacheable(value = [CACHEKEYS.USER_PERM], key = "#id")
    override fun getPermissionByUserId(id: Long): Set<String> {
        val role = sysUserRoleService.getRoleByUserId(id)
        return baseMapper.selectBatchIds(role.permIds?.split(','))
                .mapNotNull { it.perm }.toSet()
    }

}
